import java.awt.*;
import javax.swing.*;
import java.util.*;


abstract public class ImageMap {
	protected static Map imageMap = new HashMap(); //  
	protected static Map cursorMap = new HashMap(); //  

	protected static class CursorInfo {
		public String path;
		public Point center;
		public String name;
		public CursorInfo(String tpath, Point tcenter, String tname) {
			path = tpath;
			center = tcenter;
			name = tname;
		}
	};

    /**
     *  ImageIcon   path
     */
    public static ImageIcon getImageIcon(String path) {
		if (imageMap.containsKey(path))
			return (ImageIcon)imageMap.get(path);
		ImageIcon img = new ImageIcon(path);
		imageMap.put(path, img);
		return img;
    }

    /**
     *  Image   path
     */
    public static Image getImage(String path) {
    	return getImageIcon(path).getImage();
    }


	public static Cursor getCursor(String path, Point center, String name) {
		CursorInfo ci = new CursorInfo(path, center, name);
		if (cursorMap.containsKey(ci))	
			return (Cursor)cursorMap.get(ci);
		Cursor cursor =  Toolkit.getDefaultToolkit().createCustomCursor(
								getImage(path),
                                center,
                                name);
        cursorMap.put(ci, cursor);
        return cursor;
	}
  
}