import javax.sound.sampled.*;
import java.io.*;
import java.util.Random;

class PlayAudio implements LineListener {

    private Clip line = null;

    private AudioPlayer owner;

    PlayAudio(AudioPlayer ap) {
        owner = ap;
    }

    public void openFile(String file) {

        try {
            //  ,  
            File f = new File(file);
            //      
            AudioFileFormat aff = AudioSystem.getAudioFileFormat(f);
            //      
            AudioFormat af = aff.getFormat();
            //    ,
            //    
            DataLine.Info info = new DataLine.Info(Clip.class, af);
            // ,     
            if (!AudioSystem.isLineSupported(info)) {
                System.err.println("Line is not supported");
                System.exit(0);
            }
            //     
            line = (Clip) AudioSystem.getLine(info);
            //     
            AudioInputStream ais = AudioSystem.getAudioInputStream(f);
            //  

            line.addLineListener(this);

            line.open(ais);
        } catch (Exception e) {
            System.err.println(e);
        }

    }

    public void start() {
        line.start();
    }

    public void stop() {
        line.stop();
    }

    public void close() {
        line.close();
    }

    /*
    * Informs the listener that a line's state has changed.  The listener can then invoke
    * <code>LineEvent</code> methods to obtain information about the event.
    * @param event a line event that describes the change
    */
    public void update(LineEvent event) {
        if (event.getType().equals(LineEvent.Type.STOP)) {
            if (owner.playMode.getIsPlaying()) {
                switch (owner.menuChooseRepeatMode.getSelectedItemIndex()) {
                    case 0:
                        int tn = owner.backGr.getTrackNum();
                        tn++;
                        if (tn == owner.backGr.getTrackTotal() + 1) tn = 1;
                        owner.backGr.setTrackNum(tn);
                        //owner.playAudio.openFile("c:\\mus\\" + tn + ".wav");
                        openFile(System.getProperty("user.dir") + "/mus/" + owner.playMode.getTracks().get(tn - 1));
                        break;
                    case 1:
                        openFile(System.getProperty("user.dir") + "/mus/" + owner.playMode.getTracks().get(owner.backGr.getTrackNum() - 1));
                        break;
                    case 2:
                        Random rand = new Random();
                        int tn2 = Math.abs(rand.nextInt()) % owner.playMode.getTracks().size();
                        owner.backGr.setTrackNum(tn2+1);
                        openFile(System.getProperty("user.dir") + "/mus/" + owner.playMode.getTracks().get(tn2));
                        break;
                }
                start();
                owner.clientArea.repaint();
            }

        } else if (event.getType().equals(LineEvent.Type.CLOSE)) {
            /*
             *There is a bug in the jdk1.3/1.4.
             *It prevents correct termination of the VM.
             *So we have to exit ourselves.
             */
            System.exit(0);
        }


    }
}